# GrandGeo

GrandGeo is a MATLAB development that allows the implementation of the DLO method for calculating the safety factor. This implementation contains three main scripts, which show: 
1) The classic DLO method
2) The DLO method including a safety factor
3) The method of searching for the critical safety factor based on DLO

Each of these scripts has the following structure: 
1) Domain generation
2) Pore pressure calculation
3) Discontinuity generation using macro element
4) Calculation of self-weight
5) Boundary calculation
6) Calculation of matrices involved in DLO
7) Optimization or search
8) Results representation

More information can be found in the related article. 

Salinas D, Zegard T (2022) Discontinuity layout optimization usingunstructured meshes and material layering in 2D. Struct. Multidiscip. Optim. 65(5):1–16
